#include "polygon.h"

Vertex *VertPtrA;
Vertex *VertPtrB;
Vertex *VertPtrC;
Vertex2d *TVA;
Vertex2d *TVB;
Vertex2d *TVC;
int      TotalHeight;
int      TopHeight;
int      BottomHeight;
int      CeilY1;
int      CeilY2;
int      CeilY3;
int      FXDLongX;
int      FXDLongDX;
int      FXDShortX;
int      FXDShortDX;
int      FXDSide1C;
int      FXDSide1DC;
int      FXDSide2C;
int      FXDSide2DC;
int      FXDSide1U;
int      FXDSide1DU;
int      FXDSide2U;
int      FXDSide2DU;
int      FXDSide1V;
int      FXDSide1DV;
int      FXDSide2V;
int      FXDSide2DV;
int      FXDSide1S;
int      FXDSide1DS;
int      FXDSide2S;
int      FXDSide2DS;
int      FXDSide1T;
int      FXDSide1DT;
int      FXDSide2T;
int      FXDSide2DT;
int      FXDSide1Z;
int      FXDSide1DZ;
int      FXDSide2Z;
int      FXDSide2DZ;
float    FLTInten1;
float    FLTInten2;
float    FLTInten3;
float    FLTZ1;
float    FLTZ2;
float    FLTZ3;
float    FLTTextureX1;
float    FLTTextureX2;
float    FLTTextureX3;
float    FLTTextureY1;
float    FLTTextureY2;
float    FLTTextureY3;
float    FLTEnvX1;
float    FLTEnvX2;
float    FLTEnvX3;
float    FLTEnvY1;
float    FLTEnvY2;
float    FLTEnvY3;
float    FLTLongDX;
float    FLTShortDX;
float    OneOverTotalDY;
float    OneOverTopDY;
float    OneOverBotDY;
float    PolyDX;
int      HorizontalDC;
int      HorizontalDU;
int      HorizontalDV;
int      HorizontalDZ;
int      HorizontalDS;
int      HorizontalDT;
int      YAddress;
int      Color;
int      UStart;
int      VStart;
int      SStart;
int      TStart;
int      SStart8;
int      TStart8;
int      CStart;
int      TextureOfsTable;
int      IBufferTable;
int      Count;
int      HDU8;
int      HDV8;
int      HDS8;
int      HDT8;
int      LAffU;
int      LAffV;
int      RAffU;
int      RAffV;
int      AffDU;
int      AffDV;
int      DrawWidth;
float    hpu;
float    hpv;
float    hpz;
int      SpanCount;
float    DivTable[16+1] = {1.0f,           1.0f,
                           0.5f,           0.3333333333f,
                           0.25f,          0.20f,
                           0.16666666667f, 0.1428571428f,
                           0.125f,         0.1111111111f,
                           0.1f,           0.0909090909f,
                           0.08333333333f, 0.0769230769f,
                           0.07142857142f, 0.0666666667f,
                           0.0625f};


int      VirtualAddress;
int      LineSize;

float    _tmp_flt     = 0.0f;
float    _tmp_half    = 0.50f;
float    _tmp_fixone  = 65536.0f;
float    _tmp_flt_63  = 63.0f;
float    _tmp_flt_255 = 255.0f;
float    _tmp_fxd2flt = 1.0f / 65536.0f;
float    FUDGE_FACTOR = 0.995f;

extern "C" void FlatPolygonASM(Triangle *Poly, char *VPage, int x);
extern "C" void GouraudPolygonASM(Triangle *Poly, char *VPage, int x);
extern "C" void FlatTexturePolygonASM(Triangle *Poly, char *VPage, int x);
extern "C" void GouraudTexturePolygonASM(Triangle *Poly, char *VPage, int x);
extern "C" void PhongSmoothPolygonASM(Triangle *Poly, char *VPage, int x);
extern "C" void FlatReflectionPolygonASM(Triangle *Poly, char *VPage, int x);
extern "C" void GouraudReflectionPolygonASM(Triangle *Poly, char *VPage, int x);
extern "C" void PhongTexturePolygonASM(Triangle *Poly, char *VPage, int x);
extern "C" void PhongReflectionPolygonASM(Triangle *Poly, char *VPage, int x);
extern "C" void UnshadedPolygonASM(Triangle *Poly, char *VPage, int x);
extern "C" void UnshadedTexturePolygonASM(Triangle *Poly, char *VPage, int x);
extern "C" void UnshadedReflectionPolygonASM(Triangle *Poly, char *VPage, int x);
extern "C" void TransUnshadedPolygonASM(Triangle *Poly, char *VPage, int x);
extern "C" void TransFlatPolygonASM(Triangle *Poly, char *VPage, int x);
extern "C" void TransGouraudPolygonASM(Triangle *Poly, char *VPage, int x);
extern "C" void TransPhongPolygonASM(Triangle *Poly, char *VPage, int x);
extern "C" void TransUnshadedTexturePolygonASM(Triangle *Poly, char *VPage, int x);
extern "C" void TransFlatTexturePolygonASM(Triangle *Poly, char *VPage, int x);
extern "C" void TransGouraudTexturePolygonASM(Triangle *Poly, char *VPage, int x);
extern "C" void TransPhongTexturePolygonASM(Triangle *Poly, char *VPage, int x);
extern "C" void TransUnshadedReflectionPolygonASM(Triangle *Poly, char *VPage, int x);
extern "C" void TransFlatReflectionPolygonASM(Triangle *Poly, char *VPage, int x);
extern "C" void TransGouraudReflectionPolygonASM(Triangle *Poly, char *VPage, int x);
extern "C" void TransPhongReflectionPolygonASM(Triangle *Poly, char *VPage, int x);
extern "C" void UnshadedPerspTexturePolygonASM(Triangle *Poly, char *VPage, int x);
extern "C" void FlatPerspTexturePolygonASM(Triangle *Poly, char *VPage, int x);
extern "C" void GouraudPerspTexturePolygonASM(Triangle *Poly, char *VPage, int x);
extern "C" void PhongPerspTexturePolygonASM(Triangle *Poly, char *VPage, int x);
extern "C" void TransUnshadedPerspTexturePolygonASM(Triangle *Poly, char *VPage, int x);
extern "C" void TransFlatPerspTexturePolygonASM(Triangle *Poly, char *VPage, int x);
extern "C" void TransGouraudPerspTexturePolygonASM(Triangle *Poly, char *VPage, int x);
extern "C" void TransPhongPerspTexturePolygonASM(Triangle *Poly, char *VPage, int x);


void UnshadedPolygon(Triangle *Poly, char *VPage, int x, int y)
{
  UnshadedPolygonASM(Poly, VPage, x);
}

void AmbientPolygon(Triangle *Poly, char *VPage, int x, int y)
{
  FlatPolygonASM(Poly, VPage, x);
}

void LambertPolygon(Triangle *Poly, char *VPage, int x, int y)
{
  FlatPolygonASM(Poly, VPage, x);
}

void GouraudPolygon(Triangle *Poly, char *VPage, int x, int y)
{
  GouraudPolygonASM(Poly, VPage, x);
}

void PhongPolygon(Triangle *Poly, char *VPage, int x, int y)
{
  PhongSmoothPolygonASM(Poly, VPage, x);
}

void UnshadedTexturePolygon(Triangle *Poly, char *VPage, int x, int y)
{
  UnshadedTexturePolygonASM(Poly, VPage, x);
}

void AmbientTexturePolygon(Triangle *Poly, char *VPage, int x, int y)
{
  FlatTexturePolygonASM(Poly, VPage, x);
}

void LambertTexturePolygon(Triangle *Poly, char *VPage, int x, int y)
{
  FlatTexturePolygonASM(Poly, VPage, x);
}

void GouraudTexturePolygon(Triangle *Poly, char *VPage, int x, int y)
{
  GouraudTexturePolygonASM(Poly, VPage, x);
}

void PhongTexturePolygon(Triangle *Poly, char *VPage, int x, int y)
{
  PhongTexturePolygonASM(Poly, VPage, x);
}

void UnshadedPerspTexturePolygon(Triangle *Poly, char *VPage, int x, int y)
{
  UnshadedPerspTexturePolygonASM(Poly, VPage, x);
}

void AmbientPerspTexturePolygon(Triangle *Poly, char *VPage, int x, int y)
{
  FlatPerspTexturePolygonASM(Poly, VPage, x);
}

void LambertPerspTexturePolygon(Triangle *Poly, char *VPage, int x, int y)
{
  FlatPerspTexturePolygonASM(Poly, VPage, x);
}

void GouraudPerspTexturePolygon(Triangle *Poly, char *VPage, int x, int y)
{
  GouraudPerspTexturePolygonASM(Poly, VPage, x);
}

void PhongPerspTexturePolygon(Triangle *Poly, char *VPage, int x, int y)
{
  PhongPerspTexturePolygonASM(Poly, VPage, x);
}

void UnshadedReflectionPolygon(Triangle *Poly, char *VPage, int x, int y)
{
  UnshadedReflectionPolygonASM(Poly, VPage, x);
}

void AmbientReflectionPolygon(Triangle *Poly, char *VPage, int x, int y)
{
  FlatReflectionPolygonASM(Poly, VPage, x);
}

void LambertReflectionPolygon(Triangle *Poly, char *VPage, int x, int y)
{
  FlatReflectionPolygonASM(Poly, VPage, x);
}

void GouraudReflectionPolygon(Triangle *Poly, char *VPage, int x, int y)
{
  GouraudReflectionPolygonASM(Poly, VPage, x);
}

void PhongReflectionPolygon(Triangle *Poly, char *VPage, int x, int y)
{
  PhongReflectionPolygonASM(Poly, VPage, x);
}

void TransUnshadedPolygon(Triangle *Poly, char *VPage, int x, int y)
{
  TransUnshadedPolygonASM(Poly, VPage, x);
}

void TransAmbientPolygon(Triangle *Poly, char *VPage, int x, int y)
{
  TransFlatPolygonASM(Poly, VPage, x);
}

void TransLambertPolygon(Triangle *Poly, char *VPage, int x, int y)
{
  TransFlatPolygonASM(Poly, VPage, x);
}

void TransGouraudPolygon(Triangle *Poly, char *VPage, int x, int y)
{
  TransGouraudPolygonASM(Poly, VPage, x);
}

void TransPhongPolygon(Triangle *Poly, char *VPage, int x, int y)
{
  TransPhongPolygonASM(Poly, VPage, x);
}

void TransUnshadedTexturePolygon(Triangle *Poly, char *VPage, int x, int y)
{
  TransUnshadedTexturePolygonASM(Poly, VPage, x);
}

void TransAmbientTexturePolygon(Triangle *Poly, char *VPage, int x, int y)
{
  TransFlatTexturePolygonASM(Poly, VPage, x);
}

void TransLambertTexturePolygon(Triangle *Poly, char *VPage, int x, int y)
{
  TransFlatTexturePolygonASM(Poly, VPage, x);
}

void TransGouraudTexturePolygon(Triangle *Poly, char *VPage, int x, int y)
{
  TransGouraudTexturePolygonASM(Poly, VPage, x);
}

void TransPhongTexturePolygon(Triangle *Poly, char *VPage, int x, int y)
{
  TransPhongTexturePolygonASM(Poly, VPage, x);
}

void TransUnshadedReflectionPolygon(Triangle *Poly, char *VPage, int x, int y)
{
  TransUnshadedReflectionPolygonASM(Poly, VPage, x);
}

void TransAmbientReflectionPolygon(Triangle *Poly, char *VPage, int x, int y)
{
  TransFlatReflectionPolygonASM(Poly, VPage, x);
}

void TransLambertReflectionPolygon(Triangle *Poly, char *VPage, int x, int y)
{
  TransFlatReflectionPolygonASM(Poly, VPage, x);
}

void TransGouraudReflectionPolygon(Triangle *Poly, char *VPage, int x, int y)
{
  TransGouraudReflectionPolygonASM(Poly, VPage, x);
}

void TransPhongReflectionPolygon(Triangle *Poly, char *VPage, int x, int y)
{
  TransPhongReflectionPolygonASM(Poly, VPage, x);
}

void TransUnshadedPerspTexturePolygon(Triangle *Poly, char *VPage, int x, int y)
{
  TransUnshadedPerspTexturePolygonASM(Poly, VPage, x);
}

void TransAmbientPerspTexturePolygon(Triangle *Poly, char *VPage, int x, int y)
{
  TransFlatPerspTexturePolygonASM(Poly, VPage, x);
}

void TransLambertPerspTexturePolygon(Triangle *Poly, char *VPage, int x, int y)
{
  TransFlatPerspTexturePolygonASM(Poly, VPage, x);
}

void TransGouraudPerspTexturePolygon(Triangle *Poly, char *VPage, int x, int y)
{
  TransGouraudPerspTexturePolygonASM(Poly, VPage, x);
}

void TransPhongPerspTexturePolygon(Triangle *Poly, char *VPage, int x, int y)
{
  TransPhongPerspTexturePolygonASM(Poly, VPage, x);
}

